>From cd5161af1c445edfce69aa27ae350a986646e435 Mon Sep 17 00:00:00 2001
From: Pavel Reichl <preichl@redhat.com>
Date: Tue, 11 Mar 2014 10:36:29 +0000
Subject: [PATCH] MAN: new general options section

Some options are relevant to multiple sections of sssd.conf. This patch adds
new sections for those.

Resolves:
https://fedorahosted.org/sssd/ticket/2218
---
 src/man/sssd.conf.5.xml | 101 +++++++++++++++++++++++++++++-------------------
 1 file changed, 62 insertions(+), 39 deletions(-)

diff --git a/src/man/sssd.conf.5.xml b/src/man/sssd.conf.5.xml
index 9668bb0c08901547ef343bbe88d88d658add706e..4c5337606418f440f7b0e1523cfb48f8bebad431 100644
--- a/src/man/sssd.conf.5.xml
+++ b/src/man/sssd.conf.5.xml
@@ -55,6 +55,68 @@
         </para>
     </refsect1>
 
+    <refsect1 id='general-options'>
+        <title>GENERAL OPTIONS</title>
+        <para>
+            Following options are usable in more than one configuration
+            sections.
+        </para>
+        <refsect2 id='all-section-options'>
+            <title>Options usable in all sections</title>
+            <para>
+              <variablelist>
+                <varlistentry>
+                    <term>debug_level (integer)</term>
+                    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
+                </varlistentry>
+                <varlistentry>
+                    <term>debug_timestamps (bool)</term>
+                    <listitem>
+                        <para>
+                            Add a timestamp to the debug messages
+                        </para>
+                        <para>
+                            Default: true
+                        </para>
+                    </listitem>
+                </varlistentry>
+                <varlistentry>
+                    <term>debug_microseconds (bool)</term>
+                    <listitem>
+                        <para>
+                            Add microseconds to the timestamp in debug messages
+                        </para>
+                        <para>
+                            Default: false
+                        </para>
+                    </listitem>
+                </varlistentry>
+              </variablelist>
+            </para>
+        </refsect2>
+
+        <refsect2 id='services-and-domains-section-options'>
+            <title>Options usable in SERVICE and DOMAIN sections</title>
+            <para>
+              <variablelist>
+                <varlistentry>
+                    <term>timeout (integer)</term>
+                    <listitem>
+                        <para>
+                            Timeout in seconds between heartbeats for this
+                            service. This is used to ensure that the process
+                            is alive and capable of answering requests.
+                        </para>
+                        <para>
+                            Default: 10
+                        </para>
+                    </listitem>
+                </varlistentry>
+              </variablelist>
+            </para>
+        </refsect2>
+    </refsect1>
+
     <refsect1 id='special-sections'>
         <title>SPECIAL SECTIONS</title>
 
@@ -279,45 +341,6 @@
             </para>
             <variablelist>
                 <varlistentry>
-                    <term>debug_level (integer)</term>
-                    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude" href="include/debug_levels.xml" />
-                </varlistentry>
-                <varlistentry>
-                    <term>debug_timestamps (bool)</term>
-                    <listitem>
-                        <para>
-                            Add a timestamp to the debug messages
-                        </para>
-                        <para>
-                            Default: true
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>debug_microseconds (bool)</term>
-                    <listitem>
-                        <para>
-                            Add microseconds to the timestamp in debug messages
-                        </para>
-                        <para>
-                            Default: false
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
-                    <term>timeout (integer)</term>
-                    <listitem>
-                        <para>
-                            Timeout in seconds between heartbeats for this
-                            service. This is used to ensure that the process
-                            is alive and capable of answering requests.
-                        </para>
-                        <para>
-                            Default: 10
-                        </para>
-                    </listitem>
-                </varlistentry>
-                <varlistentry>
                     <term>reconnection_retries (integer)</term>
                     <listitem>
                         <para>
-- 
1.8.4.2